package org.netkernel.lang.beanshell.endpoint;

import org.netkernel.container.IKernel;
import org.netkernel.layer0.meta.impl.TransreptorMetaBuilder2;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFRequestReadOnly;
import org.netkernel.layer0.nkf.INKFResolutionContext;
import org.netkernel.layer1.representation.IDeterminateStringRepresentation;
import org.netkernel.module.standard.endpoint.StandardMonoEndpointImpl;
import org.netkernel.urii.ISpace;
import org.netkernel.lang.beanshell.representation.BeanShellRepresentation;


public class BeanShellCompiler extends StandardMonoEndpointImpl
{
	public BeanShellCompiler()
	{	declareThreadSafe();
	}
	
	public void onCommissionEndpoint(IKernel aKernel, ISpace aContext) throws Exception
	{	super.onCommissionEndpoint(aKernel, aContext);
	
		TransreptorMetaBuilder2 builder = new TransreptorMetaBuilder2();
		builder.addFromRepresentation(Object.class);
		builder.addResponseClass(BeanShellRepresentation.class);
		builder.setVerbs(INKFRequestReadOnly.VERB_TRANSREPRESENT);

		builder.setName("Beanshell Compiler");
		mMeta=builder.getMeta(aKernel.getLogger());
	}	
	
	public void onResolve(INKFResolutionContext aContext) throws Exception
	{	super.onResolve(aContext);
	}
		
	public void onTransrept(INKFRequestContext aHelper) throws Exception
	{	
		IDeterminateStringRepresentation rep = (IDeterminateStringRepresentation)aHelper.sourcePrimary(IDeterminateStringRepresentation.class);
		String input = rep.getString();
		BeanShellRepresentation script = new BeanShellRepresentation(input,aHelper.getThisRequest().getIdentifier(),aHelper);
		aHelper.createResponseFrom(script);
	}
}
