package org.netkernel.lang.beanshell.endpoint;

import org.netkernel.layer0.nkf.*;
import org.netkernel.layer0.nkf.impl.NKFContextImpl;
import org.netkernel.layer0.util.RequestScopeClassLoader;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.lang.beanshell.representation.BeanShellRepresentation;


public class BeanShellRuntime extends StandardAccessorImpl
{
	public static final String ARG_OPERATOR="operator";
	
	public BeanShellRuntime()
	{	declareThreadSafe();
	}
				
	public void onRequest(INKFRequestContext aContext) throws Exception
	{	
		if (aContext.getThisRequest().getVerb()==INKFRequestReadOnly.VERB_META)
		{	super.onMeta(aContext);
		}
		else
		{	String scriptId=aContext.getThisRequest().getArgumentValue(ARG_OPERATOR);
			((NKFContextImpl)aContext).setRuntimeSourceIdentifier(scriptId);
			BeanShellRepresentation script = (BeanShellRepresentation)aContext.source(scriptId, BeanShellRepresentation.class);
			RequestScopeClassLoader cl = new RequestScopeClassLoader(aContext.getKernelContext().getThisKernelRequest().getRequestScope());
			script.execute(aContext,cl);
		}
	}
	
}
